<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scheduling_mail_history".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "SchedulingMailHistory".
 *
 * Columns in table "scheduling_mail_history" available as properties of the model,
 * followed by relations of table "scheduling_mail_history" available as properties of the model.
 *
 * @property string $id
 * @property integer $localization_id
 * @property string $scheduling_mail_id
 * @property integer $provider_id
 * @property integer $patient_id
 * @property integer $partner_site_id
 * @property string $appointment_type
 * @property string $appointment_for
 * @property string $status
 * @property string $first_name
 * @property string $last_name
 * @property string $cell_phone
 * @property string $email
 * @property string $appointment_date
 * @property string $date_time
 * @property string $time_start
 * @property string $time_end
 * @property string $ny_start_datetime
 * @property integer $insurance_id
 * @property integer $insurance_company_id
 * @property string $insurance_other_plan
 * @property integer $prescription
 * @property integer $returning_patient
 * @property integer $visit_reason_id
 * @property string $reason
 * @property string $previous_date
 * @property string $previous_time_start
 * @property string $previous_time_end
 * @property string $date_added
 * @property string $date_updated
 * @property integer $review_mail
 * @property integer $practice_id
 * @property string $source
 * @property string $emr_appointment_id
 * @property string $emr_date_sent
 * @property string $emr_aditional_information
 * @property integer $reminder_mail
 * @property integer $reminder_sms
 * @property integer $reminder_autocall
 * @property integer $reminder_staffcall
 * @property string $insurance_company_other
 * @property string $internal_notes
 * @property integer $scheduling_mail_ehr_patient_id
 * @property integer $updated_by_account_id
 *
 * @property Account $updatedByAccount
 * @property SchedulingMail $schedulingMail
 */
abstract class BaseSchedulingMailHistory extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scheduling_mail_history';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'SchedulingMailHistory|SchedulingMailHistories', $n);
    }

    public static function representingColumn()
    {
        return 'appointment_type';
    }

    public function rules()
    {
        return array(
            array('scheduling_mail_id, status, first_name, last_name, cell_phone, email, appointment_date, date_added, date_updated', 'required'),
            array('localization_id, provider_id, patient_id, partner_site_id, insurance_id, insurance_company_id, prescription, returning_patient, visit_reason_id, review_mail, practice_id, reminder_mail, reminder_sms, reminder_autocall, reminder_staffcall, scheduling_mail_ehr_patient_id, updated_by_account_id', 'numerical', 'integerOnly'=>true),
            array('scheduling_mail_id', 'length', 'max'=>10),
            array('appointment_type, status, date_time', 'length', 'max'=>1),
            array('appointment_for', 'length', 'max'=>5),
            array('first_name, last_name, cell_phone, insurance_other_plan, insurance_company_other', 'length', 'max'=>50),
            array('email', 'length', 'max'=>100),
            array('reason, source', 'length', 'max'=>255),
            array('emr_appointment_id', 'length', 'max'=>40),
            array('time_start, time_end, ny_start_datetime, previous_date, previous_time_start, previous_time_end, emr_date_sent, emr_aditional_information, internal_notes', 'safe'),
            array('localization_id, provider_id, patient_id, partner_site_id, appointment_type, appointment_for, date_time, time_start, time_end, ny_start_datetime, insurance_id, insurance_company_id, insurance_other_plan, prescription, returning_patient, visit_reason_id, reason, previous_date, previous_time_start, previous_time_end, review_mail, practice_id, source, emr_appointment_id, emr_date_sent, emr_aditional_information, reminder_mail, reminder_sms, reminder_autocall, reminder_staffcall, insurance_company_other, internal_notes, scheduling_mail_ehr_patient_id, updated_by_account_id', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, localization_id, scheduling_mail_id, provider_id, patient_id, partner_site_id, appointment_type, appointment_for, status, first_name, last_name, cell_phone, email, appointment_date, date_time, time_start, time_end, ny_start_datetime, insurance_id, insurance_company_id, insurance_other_plan, prescription, returning_patient, visit_reason_id, reason, previous_date, previous_time_start, previous_time_end, date_added, date_updated, review_mail, practice_id, source, emr_appointment_id, emr_date_sent, emr_aditional_information, reminder_mail, reminder_sms, reminder_autocall, reminder_staffcall, insurance_company_other, internal_notes, scheduling_mail_ehr_patient_id, updated_by_account_id', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'updatedByAccount' => array(self::BELONGS_TO, 'Account', 'updated_by_account_id'),
            'schedulingMail' => array(self::BELONGS_TO, 'SchedulingMail', 'scheduling_mail_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'localization_id' => Yii::t('app', 'Localization'),
            'scheduling_mail_id' => null,
            'provider_id' => Yii::t('app', 'Provider'),
            'patient_id' => Yii::t('app', 'Patient'),
            'partner_site_id' => Yii::t('app', 'Partner Site'),
            'appointment_type' => Yii::t('app', 'Appointment Type'),
            'appointment_for' => Yii::t('app', 'Appointment For'),
            'status' => Yii::t('app', 'Status'),
            'first_name' => Yii::t('app', 'First Name'),
            'last_name' => Yii::t('app', 'Last Name'),
            'cell_phone' => Yii::t('app', 'Cell Phone'),
            'email' => Yii::t('app', 'Email'),
            'appointment_date' => Yii::t('app', 'Appointment Date'),
            'date_time' => Yii::t('app', 'Date Time'),
            'time_start' => Yii::t('app', 'Time Start'),
            'time_end' => Yii::t('app', 'Time End'),
            'ny_start_datetime' => Yii::t('app', 'Ny Start Datetime'),
            'insurance_id' => Yii::t('app', 'Insurance'),
            'insurance_company_id' => Yii::t('app', 'Insurance Company'),
            'insurance_other_plan' => Yii::t('app', 'Insurance Other Plan'),
            'prescription' => Yii::t('app', 'Prescription'),
            'returning_patient' => Yii::t('app', 'Returning Patient'),
            'visit_reason_id' => Yii::t('app', 'Visit Reason'),
            'reason' => Yii::t('app', 'Reason'),
            'previous_date' => Yii::t('app', 'Previous Date'),
            'previous_time_start' => Yii::t('app', 'Previous Time Start'),
            'previous_time_end' => Yii::t('app', 'Previous Time End'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'review_mail' => Yii::t('app', 'Review Mail'),
            'practice_id' => Yii::t('app', 'Practice'),
            'source' => Yii::t('app', 'Source'),
            'emr_appointment_id' => Yii::t('app', 'Emr Appointment'),
            'emr_date_sent' => Yii::t('app', 'Emr Date Sent'),
            'emr_aditional_information' => Yii::t('app', 'Emr Aditional Information'),
            'reminder_mail' => Yii::t('app', 'Reminder Mail'),
            'reminder_sms' => Yii::t('app', 'Reminder Sms'),
            'reminder_autocall' => Yii::t('app', 'Reminder Autocall'),
            'reminder_staffcall' => Yii::t('app', 'Reminder Staffcall'),
            'insurance_company_other' => Yii::t('app', 'Insurance Company Other'),
            'internal_notes' => Yii::t('app', 'Internal Notes'),
            'scheduling_mail_ehr_patient_id' => Yii::t('app', 'Scheduling Mail Ehr Patient'),
            'updated_by_account_id' => null,
            'updatedByAccount' => null,
            'schedulingMail' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id, true);
        $criteria->compare('localization_id', $this->localization_id);
        $criteria->compare('scheduling_mail_id', $this->scheduling_mail_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('patient_id', $this->patient_id);
        $criteria->compare('partner_site_id', $this->partner_site_id);
        $criteria->compare('appointment_type', $this->appointment_type, true);
        $criteria->compare('appointment_for', $this->appointment_for, true);
        $criteria->compare('status', $this->status, true);
        $criteria->compare('first_name', $this->first_name, true);
        $criteria->compare('last_name', $this->last_name, true);
        $criteria->compare('cell_phone', $this->cell_phone, true);
        $criteria->compare('email', $this->email, true);
        $criteria->compare('appointment_date', $this->appointment_date, true);
        $criteria->compare('date_time', $this->date_time, true);
        $criteria->compare('time_start', $this->time_start, true);
        $criteria->compare('time_end', $this->time_end, true);
        $criteria->compare('ny_start_datetime', $this->ny_start_datetime, true);
        $criteria->compare('insurance_id', $this->insurance_id);
        $criteria->compare('insurance_company_id', $this->insurance_company_id);
        $criteria->compare('insurance_other_plan', $this->insurance_other_plan, true);
        $criteria->compare('prescription', $this->prescription);
        $criteria->compare('returning_patient', $this->returning_patient);
        $criteria->compare('visit_reason_id', $this->visit_reason_id);
        $criteria->compare('reason', $this->reason, true);
        $criteria->compare('previous_date', $this->previous_date, true);
        $criteria->compare('previous_time_start', $this->previous_time_start, true);
        $criteria->compare('previous_time_end', $this->previous_time_end, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('review_mail', $this->review_mail);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('source', $this->source, true);
        $criteria->compare('emr_appointment_id', $this->emr_appointment_id, true);
        $criteria->compare('emr_date_sent', $this->emr_date_sent, true);
        $criteria->compare('emr_aditional_information', $this->emr_aditional_information, true);
        $criteria->compare('reminder_mail', $this->reminder_mail);
        $criteria->compare('reminder_sms', $this->reminder_sms);
        $criteria->compare('reminder_autocall', $this->reminder_autocall);
        $criteria->compare('reminder_staffcall', $this->reminder_staffcall);
        $criteria->compare('insurance_company_other', $this->insurance_company_other, true);
        $criteria->compare('internal_notes', $this->internal_notes, true);
        $criteria->compare('scheduling_mail_ehr_patient_id', $this->scheduling_mail_ehr_patient_id);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
